<?php
/**
 * @package comments-link-optimization
 */
/*
Plugin Name: Comments Link Optimization
Plugin URI: http://lite3.cn/comments-link-optimization/
Description: Comments Link Optimization waht prevent all search engine crawl your comments link. 
Version: 1.2
Author: lite3
Author URI: http://lite3.cn/
License: GPLv2 or later
*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

//comments link redirect
function add_redirect_comment_text($text = ''){
	$pos = stripos($text, 'href=');
	while($pos !== FALSE){
		if(('"' == $text[$pos+5] || '\'' == $text[$pos+5]) &&
		'#' != $text[$pos+6]){
			$text = substr($text, 0, $pos+6) . get_option('home') . '/?r=' . substr($text, $pos + 6);
			$pos += 26;
		}else{
			$pos += 7;
		}
		$pos = stripos($text, 'href=', $pos);
	}
	return $text;
}
add_filter('comment_text', 'add_redirect_comment_text', 99);

function add_redirect_comment_url($link = ''){
	if($link){
		$link = get_option('home') . '/?r=' . $link;
	}
	return $link;
}
add_filter('comment_url', 'add_redirect_comment_url', 99);

function check_robots(){
	$path = parse_url(get_option('home') . '/');
	$root = str_replace( $_SERVER["PHP_SELF"], '', $_SERVER["SCRIPT_FILENAME"] );
	$robots_path = $root . '/robots.txt';
	
	$m_time = 0;
	if(file_exists($robots_path)){
		$m_time = filemtime($robots_path);
	}
	
	$old_time = get_option('robots_modify_time');
	if(FALSE == $old_time || $old_time != $m_time || 0 == $m_time){
		$disallow = 'Disallow: ' . $path['path'] . '?r=*';
		$str = file_get_contents($robots_path);
		if(FALSE === strpos($str, $disallow)){
			$str .= "\n" . $disallow;
			file_put_contents($robots_path, $str);
			$m_time = filemtime($robots_path);
		}
		
		if(FALSE == $old_time){
			add_option('robots_modify_time', $m_time);
		}else{
			update_option('robots_modify_time', $m_time);
		}
	}
}

function redirect_comment_link(){
	$redirect = $_GET['r'];
	if($redirect){
		if('' == $_SERVER['HTTP_REFERER'] || strpos($_SERVER['HTTP_REFERER'],get_option('home')) !== false){
			header("Location: $redirect");
		}else {
			header('Location: ' . get_option('home'));
		}
		exit;
	}
	
	check_robots();
}
add_action('init', 'redirect_comment_link');


?>
